<template>
  <v-container
    fluid
    class="pa-0"
    style="background-color: transparent !important;"
  >
    <v-row dense>
      <v-col cols="12">
        <account-balance v-if="authAccount" :account="authAccount" />
      </v-col>
      <v-col cols="12" v-if="buyOffers.length">
        <offers-list :offers="buyOffers" @buy="buyOffer">
          <template v-slot:header>
            <v-card-title
              class="pb-0 pt-1"
              style="background-color: transparent !important;"
            >
              <p style="font-size: 14px" class="pb-0 mb-0">
                {{ buyOffers.length ? 'Купить' : 'Предложений на покупку нет' }}
              </p>
            </v-card-title>
          </template>
        </offers-list>
      </v-col>
      <v-col cols="12">
        <offers-list :offers="sellOffers" @sell="sellOffer">
          <template v-slot:header>
            <v-card-title class="pb-0">
              <p style="font-size: 14px">
                {{
                  sellOffers.length ? 'Продать' : 'Предложений на продажу нет'
                }}
              </p>
            </v-card-title>
          </template>
        </offers-list>
      </v-col>
    </v-row>
    <offer-sell-dialog
      :offer.sync="sellOfferData"
      :bank-details="bankDetails"
      :auth-info="authInfo"
    ></offer-sell-dialog>
  </v-container>
</template>

<script lang="ts">
import AccountBalance from '@/components/account/AccountBalance.vue';
import Vue from 'vue';
import Component from 'vue-class-component';
import {
  AccountResponse,
  BankDetailsApiListRequest,
  BankDetailsResponse,
  OfferApiListRequest,
  OfferResponse,
  PayOfferCommand
} from '@/api/ledius-token';
import { AuthInfoResponse } from '@/domain/response/auth/info/AuthInfoResponse';
import { safeCall } from '@/utils';
import OffersList from '@/components/offers/OffersList.vue';
import { OfferStatusEnum, OfferTypeEnum } from '@/api/patch/ledius-token.enums';
import OfferSellDialog from '@/components/offers/OfferSellDialog.vue';

@Component({
  components: {
    AccountBalance,
    OffersList,
    OfferSellDialog
  }
})
export default class ExchangeView extends Vue {
  private sellOfferData: OfferResponse | null = null;

  private get authAccount(): AccountResponse {
    return this.$store.getters['exchange/account/authAccount'];
  }

  private get buyOffers(): OfferResponse[] {
    return this.$store.getters['exchange/offers/buyOffers'];
  }

  private get sellOffers(): OfferResponse[] {
    return this.$store.getters['exchange/offers/sellOffers'];
  }

  private get authInfo(): AuthInfoResponse {
    return this.$store.getters['auth/info'];
  }

  private get bankDetails(): BankDetailsResponse[] {
    return this.$store.getters['exchange/bankDetails/bankDetails'];
  }

  private async mounted(): Promise<void> {
    await Promise.all([
      this.ensureAccount(),
      this.fetchOffers(),
      this.fetchBankDetails()
    ]);
  }

  private async fetchOffers(): Promise<void> {
    await Promise.all([
      this.$store.dispatch('exchange/offers/fetchOffers', {
        status: OfferStatusEnum.OPENED,
        type: OfferTypeEnum.BUY
      } as OfferApiListRequest),
      this.$store.dispatch('exchange/offers/fetchOffers', {
        status: OfferStatusEnum.OPENED,
        type: OfferTypeEnum.SELL
      } as OfferApiListRequest)
    ]);
  }

  private async fetchBankDetails(): Promise<void> {
    await this.$store.dispatch('exchange/bankDetails/fetch', {
      userId: this.authInfo.id
    } as BankDetailsApiListRequest);
  }

  private async buyOffer(offer: OfferResponse): Promise<void> {
    await this.$store.dispatch('exchange/offers/pay', {
      id: offer.id,
      reservedBy: this.authInfo.id
    } as PayOfferCommand);
  }

  private async sellOffer(offer: OfferResponse): Promise<void> {
    this.sellOfferData = offer;
  }

  private async ensureAccount(): Promise<void> {
    await safeCall(() =>
      this.$store.dispatch('exchange/account/fetchAccount', this.authInfo.id)
    );
    if (!this.authAccount) {
      await safeCall(() =>
        this.$store.dispatch('exchange/account/create', {
          userId: this.authInfo.id
        })
      );
      await safeCall(() =>
        this.$store.dispatch('exchange/account/fetchAccount', this.authInfo.id)
      );
    }
  }
}
</script>

<style scoped></style>
